<template>
  <section class="applicability">
    <div
      v-if="showContentInBody"
      :class="showContentInBody">
      <!-- TODO: содержимое этого блока и script абсолютно идентичны применяемости из модалки-->
      <!-- TODO: components/redesign/app-modals/app-modal-applicability.vue -->
      <!-- TODO: необходимо этот блок вынести, чтобы он формировался только в 1 месте!-->

      <div class="applicability-header">
        <h2 class="heading _prime-font __medium">
          Подходит к автомобилям
        </h2>
        <div class="input -action-search">
          <input
            class="input-field"
            type="text"
            placeholder="Марка, модель или модификация"
            @input="onInput">
          <span class="input-action _search">
            <img
              svg-inline
              src="~/assets/svg/redesign/magnifer-bold.svg">
          </span>
        </div>
      </div>
      <div class="applicability-body">
        <div class="applicability-table">
          <div class="applicability-table-header">
            <div class="tr">
              <div
                v-for="(field, i) in structure"
                :key="`table-th-${i}`"
                :class="`th _${field.name}`">
                <template v-if="field.sorting.has">
                  <!-- Классы для направления сортировки: -sorting-up / -sorting-down -->
                  <button
                    class="table-button-sorting"
                    :class="sortClasses[field.sorting.criteria]"
                    @click="orderChange(field.sorting.criteria)">
                    <span>{{ field.title }}</span>
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/sorting-none.svg">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/sorting.svg">
                  </button>
                </template>
                <template v-else>
                  {{ field.title }}
                </template>
              </div>
            </div>
          </div>
          <div class="applicability-table-body">
            <div
              class="tr"
              v-for="(entity, j) in filteredEntities"
              :key="`${entity[structure[0].name] + j}`">
              <div
                class="td"
                v-for="(field, k) in structure"
                :key="`heading-${j}-${k}`"
                :class="`_${field.name}`">
                <TextHighlight :queries="queries">
                  {{ entity[field.name] }}
                </TextHighlight>
              </div>
            </div>
          </div>
          <div
            class="applicability-table-footer"
            v-show="!filteredEntities.length">
            <span>По вашему запросу не найдено подходящих автомобилей</span>
          </div>
        </div>
      </div>
    </div>

    <div
      v-if="showContentInModal"
      :class="showContentInModal">
      <no-ssr>
        <AppModalApplicability
          v-scroll-lock="visibleModal"
          :visible="visibleModal"
          :entities="entities"
          :structure="structure"
          @before-close="beforeClose"/>
      </no-ssr>
    </div>
  </section>
</template>

<script>
import { orderBy, has, isEmpty } from 'lodash-es';
import OrderDirections from '~/assets/js/enums/order-directions';
import AppModalApplicability from '~/components/redesign/app-modals/app-modal-applicability';

const TextHighlight = process.client
  ? require('vue-text-highlight').default
  : require('~/components/text-highlight-stub').default;

export default {
  name: 'PartApplicability',
  components: {
    AppModalApplicability,
    TextHighlight,
  },
  model: {
    prop: 'visibleModal',
    event: 'visibleModal',
  },
  props: {
    entities: {
      type: Array,
      default() {
        return [];
      },
    },
    structure: {
      type: Array,
      default() {
        return [];
      },
    },
    showContent: {
      type: Object,
      default() {
        return {
          desktop: 'body',
          mobile: 'body',
        };
      },
    },
    visibleModal: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      searchString: '',
      order: {
        field: this.structure[0].name,
        direction: OrderDirections.ASC,
      },
      queries: [],
    };
  },
  computed: {
    showContentInBody() {
      let className = false;
      if (this.showContent.desktop === 'body') {
        className = '_desktopShown';
      }
      if (this.showContent.mobile === 'body') {
        className = '_mobileShown';
      }
      if (this.showContent.desktop === 'body' && this.showContent.mobile === 'body') {
        className = '_anywhereShown';
      }

      return className;
    },
    showContentInModal() {
      let className = false;
      if (this.showContent.desktop === 'modal') {
        className = '_desktopShown';
      }
      if (this.showContent.mobile === 'modal') {
        className = '_mobileShown';
      }
      if (this.showContent.desktop === 'modal' && this.showContent.mobile === 'modal') {
        className = '_anywhereShown';
      }

      return className;
    },
    filteredEntities() {
      return orderBy(this.entities, [this.order.field], [this.order.direction])
        .filter(item => isEmpty(this.queries) || this.hasMatch(item));
    },
    sortClasses() {
      const direction = Object.assign({}, this.$options.direction);

      if (has(direction, this.order.field)) {
        direction[this.order.field] = (this.order.direction === OrderDirections.ASC ? '-sorting-up' : '-sorting-down');
      }

      return direction;
    },
  },
  created() {
    this.$options.direction = this.structure.reduce((acc, currentField) => {
      acc[currentField.name] = 'none';
      return acc;
    }, {});
  },
  methods: {
    onInput(value) {
      this.queries = value.target.value.trim().split(/\s+/);
      this.$emit('input', this.queries);
    },
    orderChange(field) {
      const newOrder = {
        field,
        direction: OrderDirections.ASC,
      };

      if (field === this.order.field) {
        newOrder.direction = this.order.direction === OrderDirections.ASC ? OrderDirections.DESC : OrderDirections.ASC;
      }
      this.order = newOrder;
    },
    hasSubstring(string, substring) {
      return string.toLowerCase().includes(substring.toLowerCase());
    },
    hasMatch(entity) {
      // return this.queries.some(query => this.hasSubstring(entity[this.structure[0].name], query))
      //         || this.queries.some(query => this.hasSubstring(entity[this.structure[1].name], query))
      //         || this.queries.some(query => this.hasSubstring(entity[this.structure[2].name], query));
      return this.queries
        .some(query => this.structure.some(field => this.hasSubstring(entity[field.name], query)));
    },
    beforeClose() {
      this.$emit('visibleModal', false);
    },
  },
};
</script>

<style lang="postcss">
  .applicability {
    .applicability-header {
      display: flex;
      justify-content: space-between;
      align-items: center;
      padding-bottom: 1.5rem;
      width: 100%;

      & > .input.-action-search {
        width: 40%;
      }
    }

    .applicability-table {
      & .tr {
        display: grid;
        grid-template-columns: 1fr 1.2fr 1.5fr;

        .th, .td {
          display: flex;
          align-items: center;
          padding: 0.5rem 1rem;
          min-width: 33.333%;

          &:first-of-type {
            padding-left: 1.25rem;
          }
          &:last-of-type {
            padding-right: 1.25rem;
          }
        }

        .td > span {
          max-width: 9.875rem;
          text-overflow: ellipsis;
          white-space: nowrap;
          overflow: hidden;
        }
      }

      & > .applicability-table-header {
        display: block;
        height: 2.75rem;
        font-size: 0.75rem;
        font-weight: var(--font-weight-bold);
        border: 1px solid var(--border-color-main);

        & .tr {
          height: 100%;
        }

        & .table-button-sorting {
          display: flex;
          align-items: flex-start;
          width: auto;
          padding: 0;
          margin: 0;
          font: inherit;
          color: inherit;
          white-space: nowrap;
          text-align: inherit;
          border: none;
          outline: none;
          box-shadow: none;
          background: none;
          cursor: pointer;

          > span {
            display: block;
            width: max-content;
          }

          .svg {
            display: block;
            flex-shrink: 0;
            margin-left: 0.25rem;
            margin-top: 0.25rem;
          }

          .svg-sorting {
            display: none;
          }

          &.-sorting-up {
            .svg-sorting {
              display: block;
              transform: rotate(180deg);
            }
            .svg-no-sorting {
              display: none;
            }
          }

          &.-sorting-down {
            .svg-sorting {
              display: block;
            }
            .svg-no-sorting {
              display: none;
            }
          }
        }
      }

      & > .applicability-table-body {
        height: auto;

        .tr {
          font-size: 0.875rem;
          color: var(--color-main);
          &:hover {
            background-color: var(--bg-lightest);
          }
        }
      }

      & > .applicability-table-footer {
        padding: 1.5rem;
        text-align: center;
      }
    }

    @media screen and (min-width: 981px) {
      ._mobileShown {
        display: none;
      }
    }

    @media screen and (max-width: 980px) {
      ._desktopShown {
        display: none;
      }
      .applicability-header {
        flex-wrap: wrap;
        padding: 1rem 1.25rem 1rem 1.25rem;

        & > .heading {
          padding-bottom: 1rem;
          width: 100%;
        }

        & > .input.-action-search {
          width: 100%;
        }
      }

      .applicability-table {
        .applicability-table-header {
          height: auto;
          font-weight: var(--font-weight-medium);
          border: none;
          border-top: 1px solid var(--border-color-main);

          .table-button-sorting .svg {
            margin-top: 0.375rem;
          }
        }

        .applicability-table-body {
          max-height: none;
          overflow: visible;
          padding-bottom: calc(1.5rem + var(--mobile-browser-bar));
        }

        .applicability-table-header .tr,
        .applicability-table-body .tr {
          font-size: 1rem;
          border-bottom: 1px solid var(--border-color-main);

          & .th, & .td {
            align-items: flex-start;
            padding: 1.25rem 0.5rem;
            font-size: 0.875rem;

            &:first-of-type {
              padding-left: 1.25rem;
            }

            &:last-of-type {
              padding-right: 1.25rem;
            }
          }
        }
      }
    }
  }
</style>
